"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const family_1 = require("../models/family");
const unit_1 = require("../models/unit");
exports.default = (store, childIDs) => {
    const family = new family_1.default(store.getNextId(), 'parent');
    const cUnit = new unit_1.default(family.id, store.getNodes(childIDs));
    cUnit.nodes.forEach((child, cIndex) => {
        const parents = store
            .getNodes(child.parents.map(p => p.id))
            .sort((a, b) => (b.gender !== store.gender) ? -1 : 0);
        if (parents.length) {
            const pUnit = new unit_1.default(family.id, parents);
            pUnit.size > 1 && cUnit.size > 1 && store.gender === child.gender
                ? cUnit.shift += 2
                : pUnit.shift = cUnit.shift + cIndex * 2;
            family.pUnits.push(pUnit);
        }
    });
    family.cUnits.push(cUnit);
    return family;
};
