"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const byChildren_1 = require("./byChildren");
const arrange_1 = require("./arrange");
exports.default = (store) => {
    const root = [...store.families.values()].filter(f => f.type === 'root');
    for (const rootFamily of root) {
        if (!rootFamily.main)
            continue;
        let stack = rootFamily.pUnitsWithParents.reverse();
        while (stack.length) {
            const familyUnit = stack.pop();
            const family = byChildren_1.default(store, familyUnit.nodes.map(node => node.id));
            const childFamily = store.getFamily(familyUnit.familyId);
            family.cID = childFamily.id;
            family.top = childFamily.top - 2;
            family.left = childFamily.left + familyUnit.shift;
            arrange_1.default(store, family);
            store.families.set(family.id, family);
            const nextUnits = family.pUnitsWithParents;
            if (nextUnits.length)
                stack = [...stack, ...nextUnits.reverse()];
        }
    }
};
