"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Store {
    constructor(nodes, rootId) {
        this.nextId = 1;
        this.families = new Map();
        this.nodes = new Map();
        nodes.forEach(node => this.nodes.set(node.id, Object.assign({}, node)));
        this.rootNode = this.nodes.get(rootId);
    }
    get gender() {
        return this.rootNode.gender;
    }
    getNextId() {
        return this.nextId++;
    }
    getNode(id) {
        const node = this.nodes.get(id);
        if (!node)
            throw new Error(`[relatives-tree::store]: can't find node with id: ${id}`);
        return node;
    }
    getNodes(ids) {
        return [...ids].map(id => this.getNode(id));
    }
    getFamily(id) {
        const family = this.families.get(id);
        if (!family)
            throw new Error(`[relatives-tree::store]: can't find family with id: ${id}`);
        return family;
    }
}
exports.default = Store;
