"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.default = (store, parents) => {
    if (!parents.length)
        return null;
    const parentNodes = [...parents];
    if (parentNodes.length === 1) {
        const parent = parentNodes[0];
        const currentSpouseLink = parent.spouses.find(link => link.type === 'married');
        if (currentSpouseLink) {
            const currentSpouse = store.getNode(currentSpouseLink.id);
            if (parent.gender === store.gender) {
                parentNodes.push(currentSpouse);
            }
            else {
                parentNodes.unshift(currentSpouse);
            }
        }
    }
    const result = {
        left: [],
        target: parentNodes,
        right: [],
    };
    if (parentNodes.length === 2) {
        result.left = parentNodes[0].spouses
            .filter(link => !parentNodes.find(node => node.id === link.id))
            .sort((a, b) => a.type === 'married' ? 1 : 0)
            .map(link => store.getNode(link.id));
        result.right = parentNodes[1].spouses
            .filter(link => !parentNodes.find(node => node.id === link.id))
            .sort((a, b) => a.type !== 'married' ? 1 : 0)
            .map(link => store.getNode(link.id));
    }
    else {
        const parent = parentNodes[0];
        if (parent.gender === store.gender) {
            result.right = parent.spouses
                .sort((a, b) => a.type !== 'married' ? 1 : 0)
                .map(link => store.getNode(link.id));
        }
        else {
            result.left = parent.spouses
                .sort((a, b) => a.type === 'married' ? 1 : 0)
                .map(link => store.getNode(link.id));
        }
    }
    return result;
};
